         org     0000
         lbr     start

; ***    R3 - bios vector
; ***    R4 - call vector
; ***    R7 - ret  vector

         org     200h
         include  bios.inc
keybuf:  equ     080h

; ************************************************
; *** Initialize all vectors and data pointers ***
; ************************************************
start:   ldi      high bios            ; get high address of bios vector
         phi      r3                   ; place into r3.1
         ldi      low bios             ; get low address of bios
         plo      r3                   ; r3 now ready to use bios
         ldi      high call            ; get high address of call vector
         phi      r4                   ; place into r4.1
         ldi      low call             ; get low address of call vector
         plo      r4                   ; r4 now ready for calls
         ldi      high ret             ; get high address of ret vector
         phi      r7                   ; place into r7
         ldi      low ret              ; get low address of ret vector
         plo      r7                   ; r7 now ready for returns
         ldi      high begin           ; get address of os beginning
         phi      r5                   ; transfer to standard PC
         ldi      low begin            ; get low address of os
         plo      r5                   ; and place into PC
         sep      r5                   ; transfer control to correct PC

begin:   ldi      f_setbd              ; fuction to get terminal baud rate
         sep      r3                   ; call bios


cmdlp:   ldi      high prompt          ; get address of prompt into R6
         phi      r6
         ldi      low prompt
         plo      r6
         ldi      f_msg                ; function to print a message
         sep      r3                   ; display message
         ldi      high keybuf          ; place address of keybuffer in R6
         phi      r6
         ldi      low keybuf
         plo      r6
         ldi      f_input              ; function to get keyboard input
         sep      r3                   ; call bios
         ldi      high crlf            ; get address of prompt into R6
         phi      r6
         ldi      low crlf  
         plo      r6
         ldi      f_msg                ; function to print a message
         sep      r3                   ; display message

         br       cmdlp                ; loop back for next command

prompt:  db       10,13,"Elf/OS Ready"
crlf:    db       10,13,0


